buildFilesystem.sh 10.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281
  1. #!/bin/bash
  2. set -x
  3. set -e
  4. # Build fs, image
  5. # This file is part of PrawnOS (https://www.prawnos.com)
  6. # Copyright (c) 2018 Hal Emmerich <hal@halemmerich.com>
  7. # PrawnOS is free software: you can redistribute it and/or modify
  8. # it under the terms of the GNU General Public License version 2
  9. # as published by the Free Software Foundation.
  10. # PrawnOS is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. # You should have received a copy of the GNU General Public License
  15. # along with PrawnOS. If not, see <https://www.gnu.org/licenses/>.
  16. #Ensure Sudo
  17. if [ ! $UID = "0" ]
  18. then
  19. echo "Please run this script with sudo, or as root:"
  20. echo "sudo $0 $*"
  21. exit 1
  22. fi
  23. if [ -z "$1" ]
  24. then
  25. echo "No kernel version supplied"
  26. exit 1
  27. fi
  28. if [ -z "$2" ]
  29. then
  30. echo "No debian suite supplied"
  31. exit 1
  32. fi
  33. if [ -z "$3" ]
  34. then
  35. echo "No base file system image filename supplied"
  36. exit 1
  37. fi
  38. KVER=$1
  39. DEBIAN_SUITE=$2
  40. BASE=$3
  41. outmnt=$(mktemp -d -p `pwd`)
  42. outdev=/dev/loop5
  43. install_resources=resources/InstallResources
  44. build_resources=resources/BuildResources
  45. script_resources=scripts/
  46. package_lists=$script_resources/package_lists.sh
  47. # Import the package lists
  48. source $package_lists
  49. #HACK XSECURELOCK our usage of stable and unstable packages has caught up to us. We end up carrying conflicting files if
  50. # we grab build-essential from stable and xsecurelock from unstable. This was fixed by grabbing build-essential from
  51. # unstable as well, but that conflicts with some of the gnome packages it seems. Luckily, we can now build xsecurelock
  52. # for buster instead of grabbing it from unstable.
  53. # I'm rethinking the build system to make (heh) this more elegant, but for now to get the build fixed I'll implement this
  54. XSECURELOCK_PATH=packages/filesystem/xsecurelock
  55. #A hacky way to ensure the loops are properly unmounted and the temp files are properly deleted.
  56. #Without this, a reboot is sometimes required to properly clean the loop devices and ensure a clean build
  57. cleanup() {
  58. set +e
  59. umount -l $outmnt > /dev/null 2>&1
  60. rmdir $outmnt > /dev/null 2>&1
  61. losetup -d $outdev > /dev/null 2>&1
  62. umount -l $outmnt > /dev/null 2>&1
  63. rmdir $outmnt > /dev/null 2>&1
  64. losetup -d $outdev > /dev/null 2>&1
  65. #delete the base file, we didn't complete our work
  66. rm -rf $BASE
  67. echo "FILESYSTEM BUILD FAILED"
  68. exit 1
  69. }
  70. trap cleanup INT TERM EXIT
  71. #layout the partitons and write filesystem information
  72. create_image() {
  73. dd if=/dev/zero of=$1 bs=$3 count=$4 conv=sparse
  74. parted --script $1 mklabel gpt
  75. cgpt create $1
  76. kernel_start=8192
  77. kernel_size=65536
  78. cgpt add -i 1 -t kernel -b $kernel_start -s $kernel_size -l Kernel -S 1 -T 5 -P 10 $1
  79. #Now the main filesystem
  80. root_start=$(($kernel_start + $kernel_size))
  81. end=`cgpt show $1 | grep 'Sec GPT table' | awk '{print $1}'`
  82. root_size=$(($end - $root_start))
  83. cgpt add -i 2 -t data -b $root_start -s $root_size -l Root $1
  84. # $root_size is in 512 byte blocks while ext4 uses a block size of 1024 bytes
  85. losetup -P $2 $1
  86. mkfs.ext4 -F -b 1024 ${2}p2 $(($root_size / 2))
  87. # mount the / partition
  88. mount -o noatime ${2}p2 $5
  89. }
  90. build_install_crossystem() {
  91. # install crossystem
  92. apt install -y vboot-utils
  93. #install clang and pre-reqs
  94. apt install -y clang uuid-dev meson pkg-config cmake libcmocka-dev cargo
  95. flashmap_src=/root/flashmap
  96. mosys_src=/root/mosys
  97. mkdir $flashmap_src
  98. mkdir $mosys_src
  99. #clone flashmap, need to build libfmap
  100. git clone https://github.com/dhendrix/flashmap.git /root/flashmap
  101. cd $flashmap_src && make all
  102. cd $flashmap_src && make install
  103. ldconfig
  104. #clone mosys. Later releases start depending on the minijail library which we would have to build, and that we don't care about anyway on linux
  105. git clone https://chromium.googlesource.com/chromiumos/platform/mosys /root/mosys
  106. cd $mosys_src && git checkout release-R69-10895.B
  107. mkdir $mosys_src/build
  108. # compile the c parts
  109. cd $mosys_src && CFLAGS="-Wno-error" CC=clang meson -Darch=arm $mosys_src/build
  110. cd $mosys_src && ninja -C $mosys_src/build
  111. # install mosys so crossystem can access it. It EXPECTS it to be right here and fails otherwise...
  112. mkdir -p /usr/sbin/
  113. cp --verbose $mosys_src/build/mosys /usr/sbin/
  114. # cleanup the source
  115. rm -rf $flashmap_src
  116. rm -rf $mosys_src
  117. # cleanup the unnecessary build packages, need the noninteractive flag as -y is not enough to avoid prompting users on remove for some reason
  118. DEBIAN_FRONTEND=noninteractive apt-get purge -y --auto-remove clang meson libcmocka-dev cargo cmake pkg-config
  119. }
  120. # create a 2GB image with the Chrome OS partition layout
  121. create_image $BASE $outdev 50M 40 $outmnt
  122. # use default debootstrap mirror if none is specified
  123. if [ "$PRAWNOS_DEBOOTSTRAP_MIRROR" = "" ]
  124. then
  125. PRAWNOS_DEBOOTSTRAP_MIRROR=http://ftp.us.debian.org/debian
  126. fi
  127. # install Debian on it
  128. export DEBIAN_FRONTEND=noninteractive
  129. # need ca-certs, gnupg, openssl to handle https apt links and key adding for deb.prawnos.com
  130. qemu-debootstrap --arch armhf $DEBIAN_SUITE --include openssl,ca-certificates,gnupg,locales,init --keyring=$build_resources/debian-archive-keyring.gpg $outmnt $PRAWNOS_DEBOOTSTRAP_MIRROR
  131. chroot $outmnt passwd -d root
  132. #Place the config files and installer script and give them the proper permissions
  133. echo -n PrawnOS > $outmnt/etc/hostname
  134. cp -R $install_resources/ $outmnt/InstallResources/
  135. # and the icons for the lockscreen and app menu
  136. mkdir $outmnt/InstallResources/icons/
  137. cp $build_resources/logo/icons/icon-small.png $outmnt/InstallResources/icons/
  138. cp $build_resources/logo/icons/ascii/* $outmnt/InstallResources/icons/
  139. cp scripts/InstallScripts/* $outmnt/InstallResources/
  140. cp $package_lists $outmnt/InstallResources/
  141. cp scripts/InstallScripts/InstallPrawnOS.sh $outmnt/
  142. chmod +x $outmnt/*.sh
  143. #Setup the chroot for apt
  144. #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  145. cp /etc/hosts $outmnt/etc/
  146. cp $build_resources/sources.list $outmnt/etc/apt/sources.list
  147. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  148. if [ "$DEBIAN_SUITE" != "sid" ]
  149. then
  150. # sid doesn't have updates or security; they're present for all other suites
  151. cat $build_resources/updates.list >> $outmnt/etc/apt/sources.list
  152. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  153. # sid doesn't have backports; it's present for all other suites
  154. cp $build_resources/backports.list $outmnt/etc/apt/sources.list.d/
  155. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list.d/backports.list
  156. #setup apt pinning
  157. cp $build_resources/backports.pref $outmnt/etc/apt/preferences.d/
  158. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/preferences.d/backports.pref
  159. # Install sid (unstable) as an additional source for bleeding edge packages.
  160. cp $build_resources/sid.list $outmnt/etc/apt/sources.list.d/
  161. #setup apt pinning
  162. cp $build_resources/sid.pref $outmnt/etc/apt/preferences.d/
  163. fi
  164. if [ "$DEBIAN_SUITE" = "buster" ]
  165. then
  166. # Install bullseye (testing) as an additional source
  167. cp $build_resources/bullseye.list $outmnt/etc/apt/sources.list.d/
  168. #setup apt pinning
  169. cp $build_resources/bullseye.pref $outmnt/etc/apt/preferences.d/
  170. fi
  171. #Bring in the deb.prawnos.com gpg keyring
  172. cp $build_resources/deb.prawnos.com.gpg.key $outmnt/InstallResources/
  173. chroot $outmnt apt-key add /InstallResources/deb.prawnos.com.gpg.key
  174. chroot $outmnt apt update
  175. #Setup the locale
  176. cp $build_resources/locale.gen $outmnt/etc/locale.gen
  177. chroot $outmnt locale-gen
  178. #Install the base packages
  179. chroot $outmnt apt update
  180. chroot $outmnt apt install -y ${base_debs_install[@]}
  181. #build and install crossystem/mosys, funky way to call the bash function inside the chroot
  182. export -f build_install_crossystem
  183. chroot $outmnt /bin/bash -ec "build_install_crossystem"
  184. #add the live-boot fstab
  185. cp -f $build_resources/external_fstab $outmnt/etc/fstab
  186. chmod 644 $outmnt/etc/fstab
  187. #Cleanup to reduce install size
  188. chroot $outmnt apt-get autoremove --purge
  189. chroot $outmnt apt-get clean
  190. #Download support for libinput-gestures
  191. #Package is copied into /InstallResources/packages
  192. chroot $outmnt apt install -y libinput-tools xdotool build-essential
  193. # we want to include all of our built packages in the apt cache for installation later, but we want to let apt download dependencies
  194. # if required
  195. # this gets tricky when we build some of the dependencies. To avoid issues
  196. # first, manually cache the deb
  197. # apt install ./local-package.deb alone doesn't work because apt will resort to downloading it from deb.prawnos.com, which we dont want
  198. # copy into /var/cache/apt/archives to place it in the cache
  199. #next call apt install -d on the ./filename or on the package name and apt will recognize it already has the package cached, so will only cache the dependencies
  200. #HACK XSECURELOCK
  201. PRAWN_ROOT=$(pwd)
  202. cd $XSECURELOCK_PATH && make
  203. cd $PRAWN_ROOT
  204. #TODO: replace with cd packages && make install $outmnt/var/cache/apt/archives/
  205. cp $XSECURELOCK_PATH/xsecurelock_*_armhf.deb $outmnt/var/cache/apt/archives/
  206. chroot $outmnt apt install -y -d xsecurelock
  207. #Download the shared packages to be installed by Install.sh:
  208. chroot $outmnt apt-get install -y -d ${base_debs_download[@]}
  209. ## DEs
  210. #Download the xfce packages to be installed by Install.sh:
  211. chroot $outmnt apt-get install -y -d ${xfce_debs_download[@]}
  212. #Download the lxqt packages to be installed by Install.sh:
  213. chroot $outmnt apt-get install -y -d ${lxqt_debs_download[@]}
  214. #Download the gnome packages to be installed by Install.sh:
  215. chroot $outmnt apt-get install -y -d ${gnome_debs_download[@]}
  216. ## GPU support
  217. #download mesa packages
  218. chroot $outmnt apt-get install -y -d ${mesa_debs_download[@]}
  219. #Cleanup hosts
  220. rm -rf $outmnt/etc/hosts #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  221. echo -n "127.0.0.1 PrawnOS" > $outmnt/etc/hosts
  222. # do a non-error cleanup
  223. umount -l $outmnt > /dev/null 2>&1
  224. rmdir $outmnt > /dev/null 2>&1
  225. losetup -d $outdev > /dev/null 2>&1
  226. echo "DONE!"
  227. trap - INT TERM EXIT